#
# DB νե饹
#
# $Id: db_proc.rb 8 2007-12-06 10:36:47Z isr $
#


class DbProc
	# DB Υơ֥빽Сֹ档
	# DB 饹ꤹơ֥빽Ȥ򸡽Ф뤿ꡣ
	TABLE_VERSION = '1.0'

	@db_proc = nil

	def get_db_obj(app, host, port, opts, dbname, user, pass)
		case app
		when 'PostgreSQL'
			require "#{LIB_DIR}/db/postgres.rb"
			return PostgresDB.new(host, port, opts, dbname, user, pass)
		else
			msg = "Can't manipulate this DB type: #{app}"
			Utils::cputs('fatal', msg)
			raise msg
		end
	end


	def initialize(app, host, port, opts, dbname, user, pass)
		# DB ˱ DB ֥Ȥ
		@db_proc = get_db_obj(app, host, port, opts, dbname, user, pass)
	end


	# ⤦֥ȤȤʤȤɬδؿƤ֤ȡ
	def close
		@db_proc.close
		@db_proc = nil
	end


	# DB ˴ؤƼåԤԻ㳰֤
	def check_db
		# ʹߡγƼå
		# 饹оݤȤơ֥빽С󤬤ꤹΤƱ
		unless @db_proc.table_version == TABLE_VERSION
			msg = "DB table version are differ: #{@db_proc.table_version} <--> #{TABLE_VERSION}"
			Utils::cputs('fatal', msg)
			raise msg
		end

		# DB ơ֥빽å 
		unless @db_proc.check_db
			msg = "Can't process this DB table structure"
			Utils::cputs('fatal', msg)
			raise msg
		end

		return true
	end


	# ᡼ե DB å
	# 
	#  rdir -> ᡼ե֤Ƥǥ쥯ȥѥ
	# TODO: 뤳
	def check_mail_db_data(rdir)
	end
end

__END__
