#
# Mail ĥ饹
#
# $Id: extmail.rb 8 2007-12-06 10:36:47Z isr $
#
require 'mailread'
require "#{LIB_DIR}/utils.rb"

$KCODE = 'e'

# mailread  Mail 饹ĥ
class Mail
	include Utils

	# 褹롣
	# Reply-To, Sender, From νǤ
	def resolv_to_address
		return self['reply-to'] if exist_address?(self['reply-to'])
		return self['sender'] if exist_address?(self['sender'])
		return self['from'] if exist_address?(self['from'])
		return ''
	end


	# resolv_to_address()  Reply-To 򳰤Ρ
	def sender_or_from
		return self['sender'] if exist_address?(self['sender'])
		return self['from'] if exist_address?(self['from'])
		return ''
	end


	# Reply-To, Sender, From Υɥ쥹ꥹȤ֤
	def get_reply_sender_from
		as = []
		as << make_address_list_from_field(self['reply-to'])
		as << make_address_list_from_field(self['sender'])
		as << make_address_list_from_field(self['from'])
		return as.flatten
	end


	# From, Sender, Reply-To ˳륢ɥ쥹뤫
	def is_address_written?(address)
		as = get_reply_sender_from
		return (as.index(address) != nil)
	end


	# Subject åץ饰ѤƤϤ̾ȥץȴФ
	# ץ饰Ѥʤ nil ֤
	def get_plugin_and_opts
		return nil, nil if self['subject']

		s = self['subject'].sub(/^\s+/, '').sub(/\s+$/, '')
		unless s =~ /^[0-9]/ or s =~ /^every/ or s =~ /^plugin:/ or s =~ /^plg:/
			return nil, nil
		end

		di, pname, opts = s.split(':', 3)
		return pname, opts
	end


	# ᡼Υإå̾ȤŬڤʷƬʸ '-' μʸʸˤ롣
	# 㤨С'Hoge-foo' Ȥʸˤ 'Hoge-Foo' ֤
	# 'hoge-Foo-foo-' Ȥʸˤ 'Hoge-Foo-Foo-' ֤
	def get_formatted_header(str)
		ret = ''
		str.split('-').each {|h|
			ret << '-' if ret.size > 0
			ret << h.capitalize
		}
		# ʸκǸ '-'  split ǥåȤ뤿ᡢǥե
		ret << '-' if str[-1].chr == '-'
		return ret
	end


	# X-Simrm-Status ˳Υơܤ뤫å롣
	# Ȥ true, ʤȤ false ֤
	# ʸʸ̤뤳Ȥդ뤳ȡ
	def is_exist_status(s)
		return false unless self['x-simrm-status']
		return self['x-simrm-status'].split(',').index(s) != nil
	end
end


__END__
